ScriptTitle=FileLauncher
FileRead,List,%A_ScriptDir%\path.txt
FileRead,Items,%A_ScriptDir%\items.txt

;GUIEBhE
Gui,Margin,0,0
Gui,add,Edit,vKW gMatch w400
Gui,+Delimiter`n
Gui,add,ListBox,Multi -E0x00000200 w400 h300 vLst Delimiter`n,
Gui,+AlwaysOnTop +ToolWindow
Gui,Show,,%ScriptTitle%

;FL_Settings.ahkɋLqꂽL[蓖Ăs
Gui,+LastFound
WinGet,myhwnd,id
Hotkey,IfWinActive,ahk_id %myhwnd%
GoSub,SetActions
Hotkey,IfWinActive
GoSub,SetGlobalActions
OnExit,Exit
return


Match:
	GuiControlGet,KW,,KW
	if KW=
	{
		if(mode="D"){
			GuiControl,-Redraw,Lst
			GuiControl,,Lst,`n
			GuiControl,,Lst,%DList%
			GuiControl,Choose,Lst,1
			GuiControl,+Redraw,Lst
		}else{
			GuiControl,,Lst,`n
		}
		return
	}
	
	
	GuiControl,-Redraw,Lst
	GuiControl,,Lst,`n

	NList=
	StringSplit,kws,KW,%A_SPACE%
	if LKW=
		p=-1
	else
		StringGetPos,p,KW,%LKW%
	If p=0
	{
		;ÕL[[hɒǋLꂽꍇA
		k:=kws%kws0%
		if k=
			return
		Loop,PARSE,LList,`n
		{
			ifInString,A_LoopField,%k%
			{
				NList=%NLIST%%A_LoopField%`n
			}
		}
	}else{
		if(Mode="D"){
			TList=%DList%
		}else{
			TList=%Items%%List%
		}
		Loop,%kws0%{
			k:=kws%A_Index%
			if k=
				continue
			Loop,PARSE,TList,`n,`r
			{
				ifInString,A_LoopField,%k%
				{
					NList=%NLIST%%A_LoopField%`n
				}
			}
			TList=%NList%
		}
	}
	GuiControl,-Redraw,Lst
	GuiControl,,Lst,`n
	GuiControl,,Lst,%NList%
	GuiControl,Choose,Lst,1
	GuiControl,+Redraw,Lst
	LList=%NList%
	LKW=%KW%
return



AddItem(str){
	global Items
	l:=VarSetCapacity(Items)
	VarSetCapacity(NItems,l+StrLen(str))
	NItems=%str%`n
	Loop,Parse,Items,`n,`r
	{
		If A_LoopField<>%str%
			NItems=%NItems%%A_LoopField%`n
	}
	Items=%NItems%
}
SaveItems(){
	global
	FileDelete,%A_ScriptDir%\items.txt
	FileAppend,%Items%,%A_ScriptDir%\items.txt
}

GetSelectedPath(){
	global Mode,DPath
	GuiControlGet,item,,Lst
	if(Mode="D"){
		return DPath . item
	}else{
		StringSplit,str,item,%A_Tab%
		return str%str0%
	}
}

ClearKeyword:
	GuiControl,,KW
return

Reset:
	GuiControl,,KW
	GoSub,ExitDir
return

/*
֘A
*/
Exit:
	SaveItems()
	ExitApp
return
Show:
	Gui,Show
return
Hide:
	GoSub,Reset
	Gui,Hide
return
ListPrev:
	ControlSend,ListBox1,{Up},ahk_id %myhwnd%
return

ListNext:
	ControlSend,ListBox1,{Down},ahk_id %myhwnd%
return


/*
It@C֘A
*/
ExecItem:
	p:=GetSelectedPath()
	AddItem(p)
	Execute(p)
return

Execute(item){
	Run,%item%
}

Open:
	item:=GetSelectedPath()
	FileGetAttrib,attr,%item%
	IfInString,attr,D
	{
		OpenDir(item)
	}else{
		Execute(item)
	}
return


/*
fBNg[h֘A
*/
OpenDir(path){
	global
	Mode=D
	DPath=%path%
	DList=
	GoSub,ClearKeyword
	Loop,%path%*,1,0
	{
		IfInString,A_LoopFileAttrib,D
		{
			DList=%DList%%A_LoopFileName%\`n
		}else{
			DList=%DList%%A_LoopFileName%`n
		}
	}
	GuiControl,-Redraw,Lst
	GuiControl,,Lst,`n
	GuiControl,,Lst,%DList%
	GuiControl,Choose,Lst,1
	GuiControl,+Redraw,Lst
	Gui,Show,NoActivate,%path%
}
UpDir:
	if,Mode=D
	{
		p=%DPath%
	}else{
		p:=GetSelectedPath()
	}
	StringTrimRight,p,p,1
	Loop{
		SplitPath,p,,p
		FileGetAttrib,attr,%p%
		IfInString,attr,D
			break
	}
	OpenDir(p . "\")
return

ExitDir:
	if(Mode="D"){
		Mode=N
		DPath=
		DList=
		Gui,Show,NoActivate,%ScriptTitle%
		GoSub,ClearKeyword
	}
return

#Include %A_ScriptDir%\FL_Settings.ahk
